(function () {
    if (window.fund) {
        return;
    }

    var responseCallbacks = {};
    var uniqueId = 1;

    function setNavigationBarTitle(params){
         var jsonStr = generateCallbackId(params);
         fundModule.setNavigationBarTitle(jsonStr);
     }

    function setNavigationBar(params){
         var jsonStr = generateCallbackId(params);
         fundModule.setNavigationBar(jsonStr);
     }

    function setNavigationBarColor(params){
         var jsonStr = generateCallbackId(params);
         fundModule.setNavigationBarColor(jsonStr);
    }

    function preloadNewsData(params) {
        var jsonStr = generateCallbackId(params);
        fundModule.preloadNewsData(jsonStr);
    }

    function registerShare(params) {
        var jsonStr = generateCallbackId(params);
        fundModule.registerShare(jsonStr);
    }

    function showShare(params){
        var jsonStr = generateCallbackId(params);
        fundModule.showShare(jsonStr);
    }

    function share(params) {
        var jsonStr = generateCallbackId(params);
        fundModule.share(jsonStr);
    }

    function presentPage(params){
         var jsonStr = generateCallbackId(params);
         fundModule.presentPage(jsonStr);
    }

    function shareWeChat(params){
        var jsonStr = generateCallbackId(params);
        fundModule.shareWeChat(jsonStr);
    }

    function registerCommentShare(params) {
        var jsonStr = generateCallbackId(params);
        fundModule.registerCommentShare(jsonStr);
    }

    function showCommentShare(params) {
        var jsonStr = generateCallbackId(params);
        fundModule.showCommentShare(jsonStr);
    }

    function request(params) {
        var jsonStr = generateCallbackId(params);
        fundModule.request(jsonStr);
    }

    function getUserInfoSync(params) {
        return JSON.parse(fundModule.getUserInfoSync(params));
    }

    function login(params) {
        var jsonStr = generateCallbackId(params);
        fundModule.login(jsonStr);
    }

    function commonLinkTo(params) {
        var jsonStr = generateCallbackId(params);
        fundModule.commonLinkTo(jsonStr);
    }

    function navigateToOrganizationHome(params) {
        var jsonStr = generateCallbackId(params);
        fundModule.navigateToOrganizationHome(jsonStr);
    }

    function updateReadNewsStatusSync(params) {
         var jsonStr = generateCallbackId(params);
         fundModule.updateReadNewsStatusSync(jsonStr);
    }

    function getReadNewsStatusSync(params) {
         var jsonStr = generateCallbackId(params);
         return fundModule.getReadNewsStatusSync(jsonStr);
    }

    function postMessageToMP(params) {
        var jsonStr = generateCallbackId(params);
        fundModule.postMessageToMP(jsonStr);
    }

    function getSystemInfoSync(params){
        var jsonStr = generateCallbackId(params);
        return JSON.parse(fundModule.getSystemInfoSync(jsonStr));
    }

    function previewImage(params){
        var jsonStr = generateCallbackId(params);
        fundModule.previewImage(jsonStr);
    }

    function getUrlConfigSync(params) {
        var jsonStr = generateCallbackId(params);
        return fundModule.getUrlConfigSync(jsonStr);
    }

    function refreshView(params) {
        var jsonStr = generateCallbackId(params);
        return fundModule.refreshView(jsonStr);
    }

    function reportMonitor(params) {
        var jsonStr = generateCallbackId(params);
        return fundModule.reportMonitor(jsonStr);
    }

    function reportException(params) {
        var jsonStr = generateCallbackId(params);
        fundModule.reportException(jsonStr);
    }

    function postDelete(params) {
        var jsonStr = generateCallbackId(params);
        return fundModule.postDelete(jsonStr);
    }

    function on(params) {
        var jsonStr = generateCallbackId(params);
        return fundModule.on(jsonStr);
    }

    function emit(params) {
        var jsonStr = generateCallbackId(params);
        return fundModule.emit(jsonStr);
    }

    function off(params) {
        var jsonStr = generateCallbackId(params);
        return fundModule.off(jsonStr);
    }

    function offAll(params) {
        var jsonStr = generateCallbackId(params);
        return fundModule.off(jsonStr);
    }

    function setStorage(params) {
        var jsonStr = generateCallbackId(params);
        fundModule.setStorage(jsonStr);
    }

    function setStorageSync(params) {
        var jsonStr = generateCallbackId(params);
        return fundModule.setStorageSync(jsonStr);
    }

    function getStorage(params) {
        var jsonStr = generateCallbackId(params);
        fundModule.getStorage(jsonStr);
    }

    function getStorageSync(key, params) {
        return fundModule.getStorageSync(key, params);
    }

    function removeStorage(params) {
        var jsonStr = generateCallbackId(params);
        fundModule.removeStorage(jsonStr);
    }

    function removeStorageSync(key, params) {
        return fundModule.removeStorageSync(params);
    }

    function clearStorage(params) {
        var jsonStr = generateCallbackId(params);
        fundModule.clearStorage(jsonStr);
    }

    function clearStorageSync(params) {
        return fundModule.clearStorageSync(params);
    }

    function setMemory(params) {
        //兼容object参数
        if (typeof params == 'object') {
            var jsonStr = generateCallbackId(params);
            return fundModule.setMemory(jsonStr);
        }
        return fundModule.setMemory(params);
    }

    function getMemory(key) {
        return fundModule.getMemory(key);
    }

    function removeMemory(key) {
        return fundModule.removeMemory(key);
    }

    function clearMemory(params) {
        var jsonStr = generateCallbackId(params);
        fundModule.clearMemory(jsonStr);
    }

    function getAuthorizeSetting(params) {
        var jsonStr = generateCallbackId(params);
        fundModule.getAuthorizeSetting(jsonStr);
    }

    function openAuthorizeSetting(params) {
        fundModule.openAuthorizeSetting(params);
    }

    /**
     * 提供给native调用. 多次回调
     */
    function _invokeJSCallbackAndKeepAlive(callbackJson) {
        execInvokeMethod(callbackJson);
    }

    /**
     * 提供给native调用. 一次性回调
     */
    function _invokeJSCallback(callbackJson) {
        var callbackId = execInvokeMethod(callbackJson);
        if (callbackId) {
            delete responseCallbacks[callbackId];
        }
    }

    function _postMessageToWeb(jsonData) {
        var messageEvent = document.createEvent("Event");
        messageEvent.initEvent("message", true, true);
        var jsonObject = JSON.parse(jsonData);
        messageEvent.data = jsonObject.data;
        messageEvent.origin = jsonObject.origin;
        window.dispatchEvent(messageEvent);
    }

    function showToast(params) {
        var jsonStr = generateCallbackId(params);
        fundModule.showToast(jsonStr);
    }

    function showTitleUserInfo(params) {
        var jsonStr = generateCallbackId(params);
        fundModule.showTitleUserInfo(jsonStr);
    }

    function commentDeleteSucceed(params) {
        var jsonStr = generateCallbackId(params);
        fundModule.commentDeleteSucceed(jsonStr);
    }

    function getFileDir(params) {
        var jsonStr = generateCallbackId(params);
        fundModule.getFileDir(jsonStr);
    }

    function saveFile(params) {
        var jsonStr = generateCallbackId(params);
        fundModule.saveFile(jsonStr);
    }

    function execInvokeMethod(callbackJson) {
        var message = JSON.parse(callbackJson);
        if (message.callbackId) {
            var responseCallback = responseCallbacks[message.callbackId];
            if (!responseCallback) {
                return;
            }

            var res = message;
            responseCallback(res);
            return message.callbackId;
        }
        return undefined;
    }

    function generateCallbackId(params) {
        var convertFunction = function (json) {
            if (params.success || params.fail || params.complete) {
                if (json.code === 1) {
                    params.success ? params.success(json.data) : ''
                } else {
                    params.fail ? params.fail(json.data) : ''
                }
                params.complete ? params.complete(json.data) : json
            }
        };

        var callbackId = 'fund_' + (uniqueId++) + '_' + new Date().getTime();
        responseCallbacks[callbackId] = convertFunction;
        if ((typeof params == 'string') && params.constructor == String) {
            return params;
        } else {
            if (params == undefined) {
                params = {};
            }
            params.callbackId = callbackId;
            return JSON.stringify(params);
        }
    }

    function generateCallbackIdForAudio(params) {
            var convertFunction = params;

            var callbackId = 'fund_' + (uniqueId++) + '_' + new Date().getTime();
            responseCallbacks[callbackId] = convertFunction;
            var res = {callbackId: callbackId};
            return JSON.stringify(res);
    }

    function bugFix() {
         fundModule.bugFix();
    }

   function navigateToApp(param) {
      fundModule.navigateToApp(JSON.stringify(param));
   }

    function setupCallback(params) {
        var jsonStr = generateCallbackIdForAudio(params);
        voiceModule.setupCallback(jsonStr);
    }

    function onNetStatusCallback(params) {
     var jsonStr = generateCallbackIdForAudio(params);
        voiceModule.onNetStatusCallback(jsonStr)
    }

    function onResignActive(params) {
         var jsonStr = generateCallbackIdForAudio(params);
            voiceModule.onResignActive(jsonStr)
    }

    function startPlay(url) {
        return voiceModule.startPlay(url);
    }

    function pause() {
        voiceModule.pause();
    }

    function stop() {
        voiceModule.stop();
    }

    function resume() {
        voiceModule.resume();
    }

    function playbackRate(rate) {
        voiceModule.playbackRate(rate);
    }

    function seekToTime(timeInSecond) {
        return voiceModule.seekToTime(timeInSecond);
    }

    function getDuration() {
        return voiceModule.getDuration();
    }

    function getCurrentTime() {
        return voiceModule.getCurrentTime();
    }

    function mute(enable) {
        voiceModule.mute(enable);
    }

    function destroy() {
        voiceModule.destroy();
    }

   function isPlaying() {
        return voiceModule.isPlaying();
    }

    function showFloatView(params) {
        voiceModule.showFloatView(params);
    }

    function closeFloatView() {
        voiceModule.closeFloatView();
    }

    function onFloatViewEvent(params) {
        var jsonStr = generateCallbackIdForAudio(params);
        voiceModule.onFloatViewEvent(jsonStr);
    }

    function offFloatViewEvent() {
         voiceModule.offFloatViewEvent();
    }

    function getFloatViewData(params) {
       var jsonStr = generateCallbackIdForAudio(params);
       voiceModule.getFloatViewData(jsonStr);
    }

    function getPlayState(params) {
       var jsonStr = generateCallbackIdForAudio(params);
       voiceModule.getPlayState(jsonStr);
    }

    function onPlayState(params) {
       var jsonStr = generateCallbackIdForAudio(params);
       voiceModule.onPlayState(jsonStr);
    }

    function setLooping(onOff) {
       return voiceModule.setLooping(onOff);
   }

   function onError(params) {
      var jsonStr = generateCallbackIdForAudio(params);
       voiceModule.onError(jsonStr);
   }

    var audioObj = {
        setupCallback,
        onNetStatusCallback,
        startPlay,
        pause,
        stop,
        resume,
        playbackRate,
        seekToTime,
        getDuration,
        getCurrentTime,
        mute,
        destroy,
        isPlaying,
        showFloatView,
        closeFloatView,
        onFloatViewEvent,
        offFloatViewEvent,
        getFloatViewData,
        getPlayState,
        onPlayState,
        setLooping,
        onError,
        onResignActive
    };

    function audio() {
        return audioObj;
    }

    var fund = window.fund = {
        setNavigationBarTitle,
        setNavigationBar,
        setNavigationBarColor,
        getSystemInfoSync,
        registerShare,
        shareWeChat,
        showShare,
        share,
        presentPage,
        registerCommentShare,
        showCommentShare,
        updateReadNewsStatusSync,
        getReadNewsStatusSync,
        commonLinkTo,
        login,
        showToast,
        navigateToOrganizationHome,
        getUserInfoSync,
        request,
        preloadNewsData,
        postMessageToMP,
        previewImage,
        getUrlConfigSync,
        refreshView,
        reportMonitor,
        reportException,
        showTitleUserInfo,
        postDelete,
        commentDeleteSucceed,
        on,
        emit,
        off,
        offAll,
        getStorage,
        getStorageSync,
        setStorage,
        setStorageSync,
        removeStorage,
        removeStorageSync,
        clearStorage,
        clearStorageSync,
        setMemory,
        getMemory,
        removeMemory,
        clearMemory,
        getAuthorizeSetting,
        openAuthorizeSetting,
        getFileDir,
        saveFile,
        _postMessageToWeb,
        _invokeJSCallback,
        _invokeJSCallbackAndKeepAlive,
        bugFix,
        audio,
        navigateToApp
    };

    var doc = document;
    var readyEvent = doc.createEvent('Events');
    readyEvent.initEvent('fundJSBridgeReady');
    window.dispatchEvent(readyEvent);
})();