// Generated by CoffeeScript 1.7.1
var ImageState, adustPlaceholder, contentLinksOnClick, downloadAllImages, imageClickToLoad, pageDidLoad, setImagePlaceholderState, showTipAtImagePlaceholder , changeSubcribeState;

ImageState = {
manuallyLoad: "点击可下载",
downLoading: "加载中...",
loadingFailed: "图片下载失败，点击重试",
loadingSuccess: "下载成功"
};


// 初始化图片状态（默认都是加在中...）
initAllImagePlaceHolderState = function() {
    var images;
    images = $('.image-placeholder-wrap');
    images.each(function() {
                setImagePlaceholderState(this.id, ImageState.downLoading);
                })
};

// 设置图片状态
setImagePlaceholderStateWithIdx = function(idx, state) {
    var image_ph_id = 'image_ph_' + idx;
    setImagePlaceholderState(image_ph_id, state);
}

// 设置图片状态
setImagePlaceholderState = function(image_ph_id, state) {
    var image_ph;
    image_ph = $('#' + image_ph_id);
    switch (state) {
        case ImageState.manuallyLoad:
        case ImageState.loadingFailed:
            image_ph.on('click', imageClickToLoad);
            break;
        case ImageState.downLoading:
            image_ph.off();
            break;
        default:
            image_ph.off();
    }
    return showTipAtImagePlaceholder(image_ph_id, state);
};

// 显示图片状态标签
showTipAtImagePlaceholder = function(imagePlaceholder, imageState) {
    var placeholder;
    placeholder = $('#' + imagePlaceholder);
    placeholder.children('.tip').remove();
    if (imageState !== ImageState.loadingSuccess) {
        return $("<span class=\"tip\">" + imageState + "</span>").appendTo(placeholder);
    }
};

// 添加关键字点击
addContentLinkClick = function() {
    //    $('article .content-link').on('click', contentLinksOnClick);
};

// 图片高度设为实际高度
adustPlaceholder = function() {
    return $('.image-placeholder-wrap').each(function() {
                                             var $this, actualHeight, actualWidth, originHeight, originWidth;
                                             $this = $(this);
                                             originWidth = $this.attr('origin-width');
                                             originHeight = $this.attr('origin-height');
                                             actualWidth = $this.width();
                                             actualHeight = originHeight / originWidth * actualWidth;
                                             return $this.height(actualHeight);
                                             });
};

// 正文链接点击事件
contentLinksOnClick = function() {
    var $this, url;
    $this = $(this);
    url = $this.attr('url');
    return SNJavascriptBridge.callNativeBlock("contentLinksOnClick", {
                                              "url": url,
                                              });
};

// 单张图片点击加载
imageClickToLoad = function() {
    var $this;
    $this = $(this);
    setImagePlaceholderState($this.attr('id'), ImageState.downLoading);
    return SNJavascriptBridge.callNativeBlock("loadImage", {
                                              "url": $this.attr('target-url'),
                                              "id": $this.attr('id')
                                              });
};

// 之前获取图片数组使用这个方法，现在不适用了，直接使用接口
downloadAllImages = function() {
    var images, results;
    images = $('.image-placeholder-wrap');
    results = [];
    images.each(function() {
                return results.push({
                                    "url": $(this).attr('target-url'),
                                    "id": $(this).attr('id')
                                    });
                });
    return SNJavascriptBridge.callNativeBlock("batchDownloadImages", {
                                              "images": results
                                              });
};

setPostTextColor = function(newsColor) {
    var content=document.getElementById('news-article');
    
    var childs=content.getElementsByTagName('p');
    for(var i=0;i<childs.length;i++){
        childs[i].style.color=newsColor;
    }
};

initADLinks = function()
{
    var ad_app_src = document.getElementsByName("ad_app_src");
    var _tempLinkUrl = null;
    var _tempLinkHTML = null;
    var isPass;
    for(var _i = 0;_i < ad_app_src.length;_i++){
        _tempLinkUrl = null;
        _tempLinkHTML = null;
        isPass = false;
        _tempLinkUrl = ad_app_src[_i].getAttribute("src_ios");
        _tempLinkHTML = ad_app_src[_i].getAttribute("src_text");
        
        if(isPass || _tempLinkUrl == null){
            continue;
        }
        var _newLink = document.createElement("a");
        _newLink.setAttribute("href",_tempLinkUrl);
        _newLink.innerHTML=_tempLinkHTML;
        ad_app_src[_i].parentNode.insertBefore(_newLink,ad_app_src[_i]);
    }
};

// 这个方法暂时不用了
function doStuff(){
    pageDidLoad();
    
    var _tables = document.getElementsByTagName("table");
    
    for(var i=0;i<_tables.length;i++){
        var _tmpTableBox = document.createElement("div");
        _tmpTableBox.className = "tableBox";
        _tables[i].parentNode.insertBefore(_tmpTableBox, _tables[i]);
        _tmpTableBox.insertBefore(_tables[i]);
        var _tipTxt = document.createElement("div");
        _tipTxt.className = "tableBoxTip";
        _tipTxt.innerHTML = "左右拖动表格，可查看剩余表格内容";
        _tmpTableBox.insertBefore(_tipTxt,_tmpTableBox.firstChild);
    }
};

//滚动到底部和顶部
function scrollToBottom() {
    var currentHeight = document.documentElement.offsetHeight;
    window.scrollTo(0, currentHeight);
}

function scrollToTop() {
    window.scrollTo(0, 0);
}


//设置字体
resetFont = function(titlefont,bodyfont,titleLineHeight,bodyLineHeight,fluctuationfont) {
    $('#news-article').css('font-size', bodyfont+"px");
    $('#news-title').css('font-size', titlefont+"px");
    $('p').css('line-height', bodyLineHeight+"px");
    $('#news-title').css('line-height', titleLineHeight+"px");
    $('.content-fluctuation').css('font-size', fluctuationfont+"px");
    
};

//设置图片
resetImage = function(idx, url, base64) {
    var elem, parent;
    elem = $('#image_ph_' + idx);
    parent = elem.parent();
    elem.remove();
    $('<img>').attr('src', base64).attr('imageIndex',idx).attr('id', 'image_ph_' + idx).attr('imageurl', url).addClass('news-image').appendTo(parent).on('click', gotoImageBrowers);
};

//设置行情图片
resetStockImage = function(idx, url, base64 ,stockindex,hrefString) {
    var elem, parent;
    elem = $('#image_ph_' + idx);
    parent = elem.parent();
    elem.remove();
    $('<img>').attr('src', base64).attr('stockIndex',stockindex).attr('hrefString',hrefString).attr('id', 'image_ph_' + idx).addClass('news-image').appendTo(parent).on('click', showStockDetail);
};

// 进入图片浏览器
gotoImageBrowers = function() {
    var $this, bounds,imageIndex, imageElem, imageId, imageURL;
    $this = $(this);
    imageElem = $this.get(0);
    imageElem.
    bounds = null;
    imageIndex = $this.attr('imageIndex')
    if (imageElem != null) {
        bounds = imageElem.getBoundingClientRect();
        bounds.width = imageElem.width;
        bounds.height = imageElem.height;
    }
    imageId = $this.attr('id');
    imageSrc = $this.attr('src');
    imageUrl = $this.attr('imageurl');
    return SNJavascriptBridge.callNativeBlock("jumptoimage", {
                                              "id": imageId,
                                              "galleryImageUrlString": imageUrl,
                                              "bounds": bounds,
                                              "imageIndex":imageIndex
                                              });
};

//如果是行情图片 跳转行情页面
function showStockDetail(){
    var $this, stockIndex,hrefString;
    $this = $(this);
    stockIndex = $this.attr('stockIndex');
    hrefString = $this.attr('hrefString');
    return SNJavascriptBridge.callNativeBlock("viewstock",{
                                              "hrefString":hrefString
                                              });
};

// 加载图片
loadImage = function(imageurl) {
    return SNJavascriptBridge.callNativeBlock("loadimage", {
                                              "imageurl": imageurl
                                              });
};

loadAd = function(index) {
    return SNJavascriptBridge.callNativeBlock("jumpAdView", {
                                              "index": index
                                              });
};



//资讯正文 table样式
(function (){
 function dealtable (table,arrW) {
 var thistable = table;
 
 //找到基金表格的class
 var thisvalue =  thistable.getAttribute("class");
 if(thisvalue=="fund-tbl"){
 return;
 }
 
 var _sWidth = document.body.clientWidth;//屏幕宽度
 
 var _firstTr = thistable.rows[0];
 if(!!_firstTr){
 var _tds = _firstTr.cells;
 if(!!_tds){
 var _ct = _tds.length;
 var total = _ct*2;
 for(var j=0;j<_ct;j++){
 if(arrW[j]>_sWidth){
 total += _sWidth;
 _tds[j].style.width = _sWidth + "px";
 }
 else{
 total += arrW[j];
 _tds[j].style.width = arrW[j] + "px";
 }
 }
 thistable.style.width = total + "px";
 }
 }
 
 var zwtable = document.createElement('div');
 zwtable.className = 'zwtable';
 zwtable.innerHTML = '<div class="tabletip">左右拖动表格，可查看剩余表格内容</div><div class="tablec"><div class="tablemovetipr"><em></em></div><div class="tablemovetipl"><em></em></div><div class="tablecbody"></div></div>';
 
 thistable.parentNode.replaceChild(zwtable, thistable);
 var tablecbody = zwtable.querySelector('.tablecbody');
 tablecbody.appendChild(thistable);
 
 var maxscroll = thistable.clientWidth - tablecbody.clientWidth;
 if ( maxscroll > 0  ) {
 var tablemovetipr = zwtable.querySelector('.tablemovetipr');
 var tablemovetipl = zwtable.querySelector('.tablemovetipl');
 tablemovetipr.style.height = thistable.clientHeight + 'px';
 tablemovetipl.style.height = thistable.clientHeight + 'px';
 tablemovetipr.style.display = 'block';
 tablecbody.onscroll = function (e){
 if ( tablecbody.scrollLeft >= maxscroll - 8 ) {
 tablemovetipr.style.display = 'none';
 }
 else{
 tablemovetipr.style.display = 'block';
 }
 if ( tablecbody.scrollLeft < 8 ) {
 tablemovetipl.style.display = 'none';
 }
 else{
 tablemovetipl.style.display = 'block';
 }
 }
 }
 else{
 zwtable.querySelector('.tabletip').style.display = 'none';
 }
 }
 var tables = document.querySelectorAll('table');
 for (var i = 0; i < tables.length; i++) {
 if(tables[i] != null && tables[i].parentNode != null && tables[i].parentNode.className == 'tablecbody'){
 return;
 }    
 var arrW = initValue(tables[i]);
 dealtable(tables[i],arrW);
 }
 
 function initValue(table){
 var thistable = table;
 
 var _rows = thistable.rows;
 for(var t=0;t<_rows.length;t++){
 var _cells = _rows[t].cells;
 for(var ti=0;ti<_cells.length;ti++){
 _cells[ti].setAttribute("width","");
 }
 }
 
 thistable.width = 'auto';
 thistable.style.margin = "0px";
 var tmptable = document.createElement('div');
 tmptable.innerHTML = '<div class="tmptable" style="width:10000px;"></div>';
 thistable.parentNode.replaceChild(tmptable, thistable);
 var tablecbody = tmptable.querySelector('.tmptable');
 tablecbody.appendChild(thistable);
 
 var arrWidth = [];
 
 
 var _firstTr = thistable.rows[0];
 if(!!_firstTr){
 var _tds = _firstTr.cells;
 if(!!_tds){
 var _ct = _tds.length;
 for(var j=0;j<_ct;j++){
 arrWidth[j] = _tds[j].offsetWidth;
 }
 }
 }
 thistable.parentNode.parentNode.replaceChild(thistable,thistable.parentNode);
 return arrWidth;
 }
 })();

addCfhButtonAction = function() {
    $('.dy-btn').click(function(e){
                       return SNJavascriptBridge.callNativeBlock("changeSubState", {});
                       });
    $('.agreea').click(function(e){
                       return SNJavascriptBridge.callNativeBlock("agreeArtical", {});
                       });
    $('.collecta').click(function(e){
                         return SNJavascriptBridge.callNativeBlock("collectArtical", {});
                         });
    $('.cfhcontent').click(function(e){
                           return SNJavascriptBridge.callNativeBlock("gotoCfh", {});
                           });
};

// 改变订阅状态
changeSubcribeState = function(subState, subCount) {
    var element = $('.dy-btn');
    var cElement = $('.cfhsubc');
    cElement.text(subCount + '订阅');
    if (subState == 0) {
        element.css('background-color','#fff');
        element.css('color','#ff4400');
        element.css('border-color','#ff4400');
        element.text('+ 订阅');
    }else {
        element.css('background-color','#f5f5f5');
        element.css('color','#999999');
        element.css('border-color','#f5f5f5');
        element.text('已订阅');
    }
};

// 获取订阅按钮的最大Y值
getSubscribeBtnVLocation = function() {
    return $('.dy-btn').offset().top + 30;
};



$(function(){
  addCfhButtonAction();
  initAllImagePlaceHolderState();
  addContentLinkClick();
  adustPlaceholder();
  });